const
end_const;

var
  vystup_regulatora = real, 0;
  casovac = integer, 0;
  ohrievac = boolean, false;
  hodnota_pre_zapisovac = real, 0;
  log_nula = real, 0;
  log_jedna = real, 0;
  citac = real, 0;
end_var;

driver
end_driver;

channel
end_channel;

timer

  sequencer dlzka_impulzu;
    timer = 0.2;
  end_sequencer;

  sequencer casovanie_regulatora;
    timer = 4;
  end_sequencer;

end_timer;

instrument

  window panel regulacia_teploty;
    owner = background;
    position = 50, 50, 500, 305;
    win_disable = zoom, maximize;
    win_title = 'Prevod analgovej veliiny na pulzne rkov modulciu';
  end_panel;

  label text;
    owner = regulacia_teploty;
    position = 250, 209;
    transparent;
    font = SYSTEM, 10, bold;
    text = 'poet impulzov FALSE';
  end_label;

  label text;
    owner = regulacia_teploty;
    position = 250, 185;
    transparent;
    font = SYSTEM, 10, bold;
    text = 'poet impulzov TRUE';
  end_label;

  meter merak;
    owner = regulacia_teploty;
    position = 396, 205, 54, 22;
    expression = log_nula;
    mode = text_display;
    low_limit = 0;
    high_limit = 100;
    dec_places = 0;
    font = SYSTEM, 10, bold;
    colors
      value = dgray;
      low_limit = dgray;
      high_limit = dgray;
    end_colors;
  end_meter;

  meter merak;
    owner = regulacia_teploty;
    position = 396, 181, 54, 22;
    expression = log_jedna;
    mode = text_display;
    low_limit = 0;
    high_limit = 100;
    dec_places = 0;
    font = SYSTEM, 10, bold;
    colors
      value = dgray;
      low_limit = dgray;
      high_limit = dgray;
    end_colors;
  end_meter;

  label text;
    owner = regulacia_teploty;
    position = 268, 33;
    transparent;
    font = SYSTEM, 10, bold;
    text = 'digitlny signl po prevode na PSM';
  end_label;

  label text;
    owner = regulacia_teploty;
    position = 250, 231;
    transparent;
    font = SYSTEM, 10, bold;
    text = 'vkon ohrievaa';
  end_label;

  label text;
    owner = regulacia_teploty;
    position = 18, 33;
    transparent;
    font = SYSTEM, 10, bold;
    text = 'simulovan vstup regultora';
  end_label;

  meter vykon;
    owner = regulacia_teploty;
    position = 396, 229, 54, 22;
    expression = vystup_regulatora * 5;
    mode = text_display;
    low_limit = 0;
    high_limit = 100;
    dec_places = 0;
    font = SYSTEM, 10, bold;
    mask = '### %';
    colors
      value = dgray;
      low_limit = dgray;
      high_limit = dgray;
    end_colors;
  end_meter;

  control simulacia_vystupu_regulatora;
    owner = regulacia_teploty;
    position = 14, 53, 88, 90;
    output = vystup_regulatora;
    content = max;
    range_to = 20;
    dec_places = 0;
    receivers = vykon;
  end_control;

  indicator ledka;
    timer = dlzka_impulzu, 2;
    owner = regulacia_teploty;
    position = 250, 33;
    expression = ohrievac;
    true_icon = 'LED16GON.ICO';
    false_icon = 'LED16-OF.ICO';
    colors
      true_paper = dgray;
      false_paper = dgray;
    end_colors;
  end_indicator;

  chart zapisovac;
    timer = dlzka_impulzu, 3;
    owner = regulacia_teploty;
    position = 250, 52, 200, 113;
    mode = sweep_graph;
    range_to = 1;
    low_limit = 0;
    high_limit = 1;
    history = 20;
    dec_places = 0;
    v_grid = 19;
    item
      expression = hodnota_pre_zapisovac;
      color = lyellow;
    end_item;
    colors
      v_grid = lgray;
    end_colors;
  end_chart;

  program PSM;
    timer = dlzka_impulzu, 1;
    begin
      if log_jedna>=citac then
        ohrievac=true;
        hodnota_pre_zapisovac=1;
      else
        ohrievac=false;
        hodnota_pre_zapisovac=0;
      end;
      citac=citac+1;
    end;
  end_program;

  program prevod_na_pocet_impulzov;
    timer = casovanie_regulatora;
    begin
      log_jedna=vystup_regulatora;
      log_nula=20-vystup_regulatora;
      citac=1;
      send merak;
    end;
  end_program;

end_instrument;

